	org $1001-2
	dw  $1001
	
ptr = $D0
dst = $D2
andvalue = $D4

plasy	= $C0
plasx	= $C1
plptr	= $C2
plptr2	= $C4
plasrow	= $C6

sptr	= $C8
scptr	= $CA
scol	= $CC
sbit	= $CD

ptr1	= $E0
ptr2	= $E2
ptr3	= $E4
ptr4	= $E6

	include "!playerv.asm"

syncvalue = $CB	; screen row
	
	dw nextln,0	; second word is line number
	db $9e
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
start
	sei
	sta $FF3F
	;
	ldx #$02
zp1	lda $00,x
	sta $1F00,x
	inx
	bne zp1
	;
	; ---
	lda #$00
	sta ptr1
	sta ptr2
	lda #$08
	sta ptr1+1
	ora #$04
	sta ptr2+1
	;
	lda #$27
	sta ptr3
	sta ptr4
	lda #$08
	sta ptr3+1
	ora #$04
	sta ptr4+1
	;
l3	lda #$CB
l1	cmp $FF1D
	bne l1
	;
	ldx #25
l2	ldy #$00
	lda $FF19
	and #$7F
	sta (ptr1),y
	sta (ptr3),y
	;
	lda #$A0
	sta (ptr2),y
	sta (ptr4),y
	;
	lda ptr1
	clc
	adc #40
	sta ptr1
	sta ptr2
	lda ptr1+1
	adc #$00
	sta ptr1+1
	ora #$04
	sta ptr2+1
	;
	lda ptr3
	clc
	adc #40
	sta ptr3
	sta ptr4
	lda ptr3+1
	adc #$00
	sta ptr3+1
	ora #$04
	sta ptr4+1
	;
	dex
	bne l2
	;
	; ---
	;
	lda ptr1
	sec
	sbc #$E7
	sta ptr1
	sta ptr2
	lda ptr1+1
	sbc #$03
	sta ptr1+1
	ora #$04
	sta ptr2+1
	;
	lda ptr3
	sec
	sbc #$E9
	sta ptr3
	sta ptr4
	lda ptr3+1
	sbc #$03
	sta ptr3+1
	ora #$04
	sta ptr4+1
	;
	lda ptr1
	cmp #20
	bne l3
	;
	; ---
	;
	lda #$0B
	sta $FF06
	;
l4	ldx #$FA
	lda $FF07
	and #$40
	beq *+4
	ldx #$F5
	;
	cpx $FF1D	; 2 frame delay
	bne *-3
	cpx $FF1D
	beq *-3
	cpx $FF1D
	bne *-3
	cpx $FF1D
	beq *-3
	;
	lda $FF19
	and #$7F
	sec
	sbc #$10
	bpl l5
	lda #$00
l5	sta $FF19
	bne l4
	; ---
	;
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$1A
	sta $FF0B
	asl $FF09
	;
	lda #$00
	sta plasx
	sta plasy
	;
	jsr PLAYER_FREQ_INIT
	;
	cli
	;
	lda #$60
	sta ptr+1
	ldy #$00
	sta ptr+1
	;
	ldx #$1F
	tya
c1	sta (ptr),y
	iny
	bne c1
	inc ptr+1
	dex
	bpl c1
	;
	; ---
	;
	lda #$3B	; turn graphics mode on
	sta $FF06
	;
	lda $FF07	; PAL/NTSC friendly
	and #$40
	ora #$18	; use $18 for multicolor
	sta $FF07
	;
	lda $FF12
	and #$03	; keep lowest 2 bits (sound)	
	ora #$18	; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
	lda #$58
	sta $FF13
	;
	lda #$40	; color map
	sta $FF14
	;
	lda #$71
	sta $FF16
	lda #$00
	sta $FF15
	sta $FF19
	;
	ldx #$00
	txa
in1	sta $0F00,x
	inx
	bne in1
	ldx #39
in2	lda tline,x
	sta $0F20,x
	lda cline,x
	sta $0B20,x
	dex
	bpl in2
	;
	; ---
	;
	jsr show_all
	jsr wait_30_frames
	jsr do_big_scroll
	jsr wait_80_frames
	jsr wipe_screen
	jsr set_colors
	jsr start_plasma
	jsr wipe_plasma
	jsr wait_80_frames
	jsr copy_logo
	jsr start_little_scroll
	jsr wait_for_space
	jsr start_voldown
	jsr end_little_scroll
	jsr wait_60_frames
	jsr stop_little_scroll
	jsr wipe_screen
	jsr do_big_scroll
	jsr stop_plasma
	jsr wipe_all
	;
	; ##############################################
	;
	sei
	;
	lda #$CC
sn1	cmp $FF1D
	bne sn1
	;
	ldx #$02
zp2	lda $1F00,x
	sta $00,x
	inx
	bne zp2
	;
	lda #$18
	sta $D1
	lda #$00
	sta $1000
	sta $D0
	tay
wipe1	sta ($D0),y
	iny
	bne wipe1
	inc $D1
	bpl wipe1
	;
	lda #$A2		; restore irq
	sta $FF0A
	asl $FF09
	;        
	lda #$B3
	sta $FFFE
	lda #$FC
	sta $FFFF
	;
	lda #$08
	sta $FF14
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	lda #$0B
	sta $FF06
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	sta $FF3E
	;
	ldx #$0F	; reset basic colors
cp1	lda $E143,x
	sta $0113,x
	dex
	bpl cp1
	;
	ldx #$FF
	txs
	;
	cli
	;
	lda #$00
	sta $053B
	lda #$93
	jsr $FFD2
	;
	lda #$F8
sn2	cmp $FF1D
	bne sn2
	;
	lda #$1B
	sta $FF06
	lda #$01
	sta $FF15
	sta $FF19
	;
	; ---
	;
	lda #$01	; logical number
	ldx #$08	; device number (8=disk)
	ldy #$01	; secondary address
	jsr $FFBA	; KERNAL: SETLFS
	;
	lda #fname_end - fname
	ldx #fname & 255
	ldy #fname >> 8
	jsr $FFBD	; KERNAL: SETNAM (Set length and filename address)
	;
	lda #$00	; 0=load
	sta $90		; clear error byte just in case
	jsr $FFD5	; KERNAL: LOADSP (Load from file)
	;
	; --- check for error
	;
	jsr $FFB7	; READSS, find out the status
	cmp #$00	; zero should mean no error
	beq NOERROR
	cmp #$40	; for serial devices, $40 means EOF was reached
	beq NOERROR
	;
	; --- disk error
	;
	lda #$0F
	ldx #$08
	tay
	jsr $FFBA	; KERNAL: SETLFS (Set LA, FA, SA) - OPEN 15, 8, 15
	;
	lda #$00
	jsr $FFBD	; KERNAL: SETNAM - no filename
	;
	jsr $FFC0	; KERNAL: OPEN (Open logical file)
	;
	ldx #$0F
	jsr $FFC6	; KERNAL: CHKIN (Open channel in)
	;
	lda #$80	; read a maximum of 128 chars
	sta $D0
	;
er1	jsr $EC8B	; Read one char
	jsr $FFD2	; KERNAL: BSOUT (Output to channel) - PRINT
	cmp #$0D	; C/R means end of information
	beq er2
	;
	dec $D0		; keep track of the read length to avoid infinite loops
	bne er1
	;
er2	lda #$0F
	jsr $FFC3	; KERNAL: CLOSE (Close logical file)
	;
	lda #$71	; reset colors
	sta $FF15
	lda #$6E
	sta $FF19
	;
	jsr $FF4F
	db "COULD NOT LOAD MAIN PROGRAM."
	db 0
	;
	jmp $8003	; READY.
	;
NOERROR	lda #$01	; set BASIC vectors to $4000
	sta $2B
	lda #$40
	sta $2C
	;
	lda $9D		; copy load end address to BASIC vectors
	sta $2D
	sta $2F
	sta $31
	lda $9E
	sta $2E
	sta $30
	sta $32
	;
	lda #$80	; flag gfx area allocated
	sta $75
	lda #$03	; mode 3
	sta $65
	lda #$20
	sta $83
	;
	jsr $8BBE	; BASIC RUN command
	jmp $8BDC
	
fname
	db "HAUPTPRO*"
fname_end
	
wait_for_space
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	bne wait_for_space
	; space is pressed
	rts

wait_30_frames
	ldx #30
	db $2C
	;	
wait_80_frames
	ldx #80
	db $2C
	;
wait_60_frames
	ldx #60
	lda #syncvalue
wf1	cmp $FF1D
	bne wf1
wf2	cmp $FF1D
	beq wf2
	;
	dex
	bpl wf1
	rts
	
stop_little_scroll
	lda #$00
	sta lscall+1
	lda #$2C
	sta sccall
	rts
	
start_little_scroll
	lda #$01
	sta lscall+1
	lda #$20
	sta sccall
	;
	jsr reset_sptr
	;
	lda #$00
	sta scol
	ldy #$04
	lda #$AA
sls1	sta $791B,y
	sta $791B+1*8,y
	sta $791B+2*8,y
	sta $791B+3*8,y
	sta $791B+4*8,y
	sta $791B+5*8,y
	sta $791B+6*8,y
	dey
	bpl sls1
	rts
	
start_plasma
	lda #$20
	sta plasma_call
	rts
	
stop_plasma
	lda #$2C
	sta plasma_call
	rts
	
show_all
	lda #$00
	sta ptr
	sta dst
	lda #$20
	sta ptr+1
	lda #$60
	sta dst+1
	;
m3	lda #$C0
	sta andvalue
	;
m0	lda $FF1D
	cmp #syncvalue
	bne m0
	;
	ldx #24
m2	ldy #$07
m1	lda (ptr),y
	and andvalue
	sta (dst),y
	dey
	bpl m1
	;
	lda ptr
	clc
	adc #$40
	sta ptr
	sta dst
	lda ptr+1
	adc #$01
	sta ptr+1
	ora #$40
	sta dst+1
	;
	dex
	bpl m2
	;
	lda ptr
	sec
	sbc #$40
	sta ptr
	sta dst
	lda ptr+1
	sbc #$1F
	sta ptr+1
	ora #$40
	sta dst+1
	;
	lda andvalue
	cmp #$FF
	beq nextcol2
	sec
	ror a
	sec
	ror a
	sta andvalue
	;
	jmp m0
	;
nextcol2
	lda ptr
	clc
	adc #$08
	sta ptr
	sta dst
	lda ptr+1
	adc #$00
	sta ptr+1
	ora #$40
	sta dst+1
	;
	lda ptr
	cmp #$40
	bne m3
	lda ptr+1
	cmp #$21
	bne m3
	;
	rts
	
wipe_all
	lda #$00
	sta ptr
	sta dst
	lda #$20
	sta ptr+1
	lda #$60
	sta dst+1
	;
w3	lda #$3F
	sta andvalue
	;
w0	lda $FF1D
	cmp #syncvalue
	bne w0
	;
	ldx #24
w2	ldy #$07
w1	lda (dst),y
	and andvalue
	sta (dst),y
	dey
	bpl w1
	;
	lda ptr
	clc
	adc #$40
	sta ptr
	sta dst
	lda ptr+1
	adc #$01
	sta ptr+1
	ora #$40
	sta dst+1
	;
	dex
	bpl w2
	;
	lda ptr
	sec
	sbc #$40
	sta ptr
	sta dst
	lda ptr+1
	sbc #$1F
	sta ptr+1
	ora #$40
	sta dst+1
	;
	lda andvalue
	beq nextcol3
	lsr a
	lsr a
	sta andvalue
	;
	jmp w0
	;
nextcol3
	lda ptr
	clc
	adc #$08
	sta ptr
	sta dst
	lda ptr+1
	adc #$00
	sta ptr+1
	ora #$40
	sta dst+1
	;
	lda ptr
	cmp #$40
	bne w3
	lda ptr+1
	cmp #$21
	bne w3
	;
	rts
	
set_colors
	lda #$83
	sta ptr
	sta dst
	lda #$40
	sta ptr+1
	ora #$04
	sta dst+1
	;
	ldx #10-1
sc2	ldy #17-1
sc1	lda #$44
	sta (ptr),y
	lda plasma_cols,x
	sta (dst),y
	dey
	bpl sc1
	;
	lda ptr
	clc
	adc #40
	sta ptr
	sta dst
	lda ptr+1
	adc #$00
	sta ptr+1
	ora #$04
	sta dst+1
	;
	dex
	bpl sc2
	;
	rts
	
copy_logo
	lda #(logo) & 255
	sta ptr
	lda #(logo) >> 8
	sta ptr+1
	;
	lda #$18
	sta dst
	lda #$64
	sta dst+1
	;
cl2	ldy #$00
	;
cl0	lda $FF1D
	cmp #syncvalue
	bne cl0
	;
	ldx #17-1	
cl1	lda (ptr),y
	sta (dst),y
	;
	tya
	clc
	adc #$08
	tay
	dex
	bpl cl1
	;
	tya
	sec
	sbc #17*8
	tay
	;
	iny
	cpy #$08
	bne cl0
	;
	lda ptr
	clc
	adc #(17*8)
	sta ptr
	lda ptr+1
	adc #$00
	sta ptr+1
	;
	lda dst
	clc
	adc #$40
	sta dst
	lda dst+1
	adc #$01
	sta dst+1
	;
	lda dst+1
	cmp #$70
	bne cl2
	;
	rts
	
wipe_screen
	lda #$18
	sta ptr
	lda #$64
	sta ptr+1
	;
a3	lda #$3F
	sta andvalue
	;
a0	lda $FF1D
	cmp #syncvalue
	bne a0
	;
	ldx #$09
a2	ldy #$07
a1	lda (ptr),y
	and andvalue
	sta (ptr),y
	dey
	bpl a1
	;
	lda ptr
	clc
	adc #$40
	sta ptr
	lda ptr+1
	adc #$01
	sta ptr+1
	;
	dex
	bpl a2
	;
	lda ptr
	sec
	sbc #$80
	sta ptr
	lda ptr+1
	sbc #$0C
	sta ptr+1
	;
	lda andvalue
	beq nextcol
	lsr a
	lsr a
	sta andvalue
	jmp a0
	;
nextcol lda ptr
	clc
	adc #$08
	sta ptr
	lda ptr+1
	adc #$00
	sta ptr+1
	;
	lda ptr
	cmp #$A0
	bne a3
	;
	rts
	
wipe_plasma
	lda #$18
	sta ptr
	lda #$64
	sta ptr+1
	;
b3	lda #$C0
	sta andvalue
	;
b0	lda $FF1D
	cmp #syncvalue
	bne b0
	;
	ldx #$09
b2	ldy #$07
b1	lda #$5A
	and andvalue
	sta (ptr),y
	dey
	bpl b1
	;
	lda ptr
	clc
	adc #$40
	sta ptr
	lda ptr+1
	adc #$01
	sta ptr+1
	;
	dex
	bpl b2
	;
	lda ptr
	sec
	sbc #$80
	sta ptr
	lda ptr+1
	sbc #$0C
	sta ptr+1
	;
	lda andvalue
	cmp #$FF
	beq nextcl2
	sec
	ror a
	sec
	ror a
	sta andvalue
	bne b0
	;
nextcl2 lda ptr
	clc
	adc #$08
	sta ptr
	lda ptr+1
	adc #$00
	sta ptr+1
	;
	lda ptr
	cmp #$A0
	bne b3
	;
	rts
	
do_big_scroll
	lda #scrolltext & 255
	sta dst
	lda #scrolltext >> 8
	sta dst+1
	;
co3	lda #$F8
	sta ptr
	lda #$42
	sta ptr+1
	;
co2	lda $FF1D
	cmp #syncvalue
	bne co2
	;
co0	ldy #$27
co1	lda (ptr),y
	clc
	adc (dst),y
	sta (ptr),y
	dey
	bpl co1
	;
	lda dst
	clc
	adc #$92
	sta dst
	lda dst+1
	adc #$00
	sta dst+1
	;
	lda ptr
	clc
	adc #$28
	sta ptr
	lda ptr+1
	adc #$00
	sta ptr+1
	;
	lda ptr
	cmp #$c0
	bne co0
	;
	; ---
	;
	lda dst
	sec
	sbc #($92*5-1) & 255
	sta dst
	lda dst+1
	sbc #($92*5-1) >> 8
	sta dst+1
	;
	lda dst
	cmp #(st1-40) & 255
	bne co3
	;
	rts
	
irq1	pha
	txa
	pha
	tya
	pha
	asl $FF09
	;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	;
	ldy #8*10
	ldx #$AC
ras1	lda raster,y
	cpx $FF1E
	bcs *-3
	sta $FF16
	nop
	dey
	bpl ras1
	;
	;dec $FF19
sccall	bit do_small_scroll
	jsr PLAYER
vdcall	bit voldown
	jsr start_scroll_raster
srcall	bit scroll_raster
	;inc $FF19
	;
lscall	lda #$00
	bne seti3
	;
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$DC
	sta $FF0B
	bne irq1end
	;
seti3	lda #irq3 & 255
	sta $FFFE
	lda #irq3 >> 8
	sta $FFFF
	lda #$A2
	sta $FF0B
	;
irq1end	pla
	tay
	pla
	tax
	pla
	rti

irq3	sta $E0
	stx $E1
	sty $E2
	;
	lda $FF1E
	cmp #$3E	; never occurs on YAPE... but does on a real machine
	beq ah16
	cmp #$3A
	beq ah12	; ahead by 12
	cmp #$36	; one cycle = HC increases by 4
	beq ah8		; ahead by 8
	cmp #$32
	beq ah4		; ahead by 4
	cmp #$2E
	beq ah0		; lowest value
	;
ah16	bit $24
ah12	bit $24
ah8	bit $24		; was on 56, needs $C, which is 3 cycles
ah4	bit $24		; was on 62
ah0			; nothing was on 6E
	nop
	nop
	nop
	nop
	nop
	nop
	bit $FF
	;
	lda #$51
	ldx #$08
	ldy #$1B
	stx $FF14
	sty $FF06
	sta $FF15
	;
	lda #irq4 & 255
	sta $FFFE
	lda #irq4 >> 8
	sta $FFFF
	lda #$AA
	sta $FF0B
	;
	lda $E0
	ldx $E1
	ldy $E2
	asl $FF09
	rti
	
irq4	sta $E0
	stx $E1
	sty $E2
	;
	lda $FF1E
	cmp #$3A
	beq ai12	; ahead by 12
	cmp #$36	; one cycle = HC increases by 4
	beq ai8		; ahead by 8
	cmp #$32
	beq ai4		; ahead by 4
	cmp #$2E
	beq ai0		; lowest value
	;
ai12	bit $24
ai8	bit $24		; was on 56, needs $C, which is 3 cycles
ai4	bit $24		; was on 62
ai0			; nothing was on 6E
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	bit $FF
	;
	lda #$00
	ldx #$40
	ldy #$3B
	stx $FF14
	sty $FF06
	sta $FF15
	;	
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$DC
	sta $FF0B
	;
	lda $E0
	ldx $E1
	ldy $E2
	asl $FF09
	rti
	
irq2	pha
	txa
	pha
	tya
	pha
	asl $FF09
	;
plasma_call
	bit do_plasma
	;
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$1A
	sta $FF0B
	;
	pla
	tay
	pla
	tax
	pla
	rti
	
start_scroll_raster
	lda $FF11
	cmp #$58
	bne ssr1
	lda #$20
	sta srcall
ssr1	rts
	
scroll_raster
	ldx #79
sr1	lda raster,x
	sta raster+1,x
	dex
	bne sr1
	;
sr3	ldx #$00
	lda raster_colors,x
	sta raster+1
	;
	inx
	cpx #4*14
	bne sr2
	ldx #$00
sr2	stx sr3+1
	rts
	
start_voldown
	lda #$20
	sta vdcall
	rts
	
voldown
vol_delay
	lda #$00
	clc
	adc #$01
	cmp #$13
	bne vd1
	lda #$00
vd1	sta vol_delay+1
	bne no_vol_down
	;
	lda VOLUME
	clc
	adc #$09
	cmp #21*9
	beq no_vol_down
	;
	sta VOLUME
no_vol_down
	rts
	
do_small_scroll
	ldx scol
	lda bits,x
	sta sbit
	;
	ldy #$00
	lda (sptr),y
	asl a
	asl a
	asl a
	tax
	;
	clc
	lda small_letters,x
	and sbit
	beq *+3
	sec
	rol $584B+6*8 
	rol $584B+5*8
	rol $584B+4*8
	rol $584B+3*8
	rol $584B+2*8
	rol $584B+1*8
	rol $584B+0*8
	;
	clc
	lda small_letters+1,x
	and sbit
	beq *+3
	sec
	rol $584B+6*8+1
	rol $584B+5*8+1
	rol $584B+4*8+1
	rol $584B+3*8+1
	rol $584B+2*8+1
	rol $584B+1*8+1
	rol $584B+0*8+1
	;
	clc
	lda small_letters+2,x
	and sbit
	beq *+3
	sec
	rol $584B+6*8+2
	rol $584B+5*8+2
	rol $584B+4*8+2
	rol $584B+3*8+2
	rol $584B+2*8+2
	rol $584B+1*8+2
	rol $584B+0*8+2
	;
	clc
	lda small_letters+3,x
	and sbit
	beq *+3
	sec
	rol $584B+6*8+3
	rol $584B+5*8+3
	rol $584B+4*8+3
	rol $584B+3*8+3
	rol $584B+2*8+3
	rol $584B+1*8+3
	rol $584B+0*8+3
	;
	clc
	lda small_letters+4,x
	and sbit
	beq *+3
	sec
	rol $584B+6*8+4
	rol $584B+5*8+4
	rol $584B+4*8+4
	rol $584B+3*8+4
	rol $584B+2*8+4
	rol $584B+1*8+4
	rol $584B+0*8+4
	;
	; ---
	;
	ldy #$00
	lda (sptr),y
	tax
	lda scol
	clc
	adc #$01
	cmp letter_widths,x
	bne dsc1
	;
	lda sptr
	clc
	adc #$01
	sta sptr
	lda sptr+1
	adc #$00
	sta sptr+1
	;
	lda (sptr),y
	bpl dsc2
	;
	jsr reset_sptr
	;
dsc2	lda #$00
dsc1	sta scol
	rts
	
reset_sptr
	lda #small_scroll_text & 255
	sta sptr
	lda #small_scroll_text >> 8
	sta sptr+1
	rts
	
end_little_scroll
	lda #sst_end & 255
	sta sptr
	lda #sst_end >> 8
	sta sptr+1
	rts
	
do_plasma
	lda #$83
	sta plptr
	lda #$40
	sta plptr+1
	;
	lda #$EB
	sta plptr2
	lda #$41
	sta plptr2+1
	;
	lda #$00
	sta plasrow
	;
	; ---
	;
pl0	lda plasy
	clc
	adc plasrow
	tax
	lda sine2,x
	sta siny1+1
	sta siny2+1
	;
	ldy #16
	;
pl1	inc plasx
	ldx plasx
	lda sine1,x
siny1	adc #$00
	tax
	lda plascolors2,x
	sta or+1
	;
	inc plasx
	ldx plasx
	lda sine1,x
siny2	adc #$00
	tax
	lda plascolors1,x
or	ora #$00
	sta (plptr),y
	sta (plptr2),y
	;
	dey
	bpl pl1
	;
	lda plasx
	sec
	sbc #17*2
	sta plasx
	;
	; ---
	;
	lda plptr
	clc
	adc #40
	sta plptr
	lda plptr+1
	adc #$00
	sta plptr+1
	;
	lda plptr2
	sec
	sbc #40
	sta plptr2
	lda plptr2+1
	sbc #$00
	sta plptr2+1
	;
	inc plasrow
	lda plasrow
	cmp #05
	bne pl0
	;
	dec plasx
	dec plasx
	inc plasy
	rts
	
raster
	db $71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	
raster_colors
	db $71,$71,$61,$71
	db $61,$61,$51,$61
	db $51,$51,$41,$51
	db $41,$41,$31,$41
	db $31,$31,$21,$31
	db $21,$21,$11,$21
	db $11,$11,$01,$11
	db $01,$01,$11,$01
	db $11,$11,$21,$11
	db $21,$21,$31,$21
	db $31,$31,$41,$31
	db $41,$41,$51,$41
	db $51,$51,$61,$51
	db $61,$61,$71,$61
	
plasma_cols
	db $EE,$44,$BB,$22,$88
	db $99,$77,$AA,$FF,$55

	org $2000
	include "pic.asm"
logo
	include "logo.asm"
	
	align 256
sine1
;256,50
	db $32,$33,$34,$36,$37,$38,$39,$3B,$3C,$3D,$3E,$3F,$41,$42,$43,$44
	db $45,$46,$47,$48,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$54
	db $55,$56,$57,$58,$59,$59,$5A,$5B,$5C,$5C,$5D,$5E,$5E,$5F,$5F,$60
	db $60,$61,$61,$61,$62,$62,$63,$63,$63,$63,$63,$64,$64,$64,$64,$64
	db $64,$64,$64,$64,$64,$64,$63,$63,$63,$63,$63,$62,$62,$61,$61,$61
	db $60,$60,$5F,$5F,$5E,$5E,$5D,$5C,$5C,$5B,$5A,$59,$59,$58,$57,$56
	db $55,$54,$54,$53,$52,$51,$50,$4F,$4E,$4D,$4C,$4B,$4A,$48,$47,$46
	db $45,$44,$43,$42,$41,$3F,$3E,$3D,$3C,$3B,$39,$38,$37,$36,$34,$33
	db $32,$31,$30,$2E,$2D,$2C,$2B,$29,$28,$27,$26,$25,$23,$22,$21,$20
	db $1F,$1E,$1D,$1C,$1A,$19,$18,$17,$16,$15,$14,$13,$12,$11,$10,$10
	db $0F,$0E,$0D,$0C,$0B,$0B,$0A,$09,$08,$08,$07,$06,$06,$05,$05,$04
	db $04,$03,$03,$03,$02,$02,$01,$01,$01,$01,$01,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$02,$02,$03,$03,$03
	db $04,$04,$05,$05,$06,$06,$07,$08,$08,$09,$0A,$0B,$0B,$0C,$0D,$0E
	db $0F,$10,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1C,$1D,$1E
	db $1F,$20,$21,$22,$23,$25,$26,$27,$28,$29,$2B,$2C,$2D,$2E,$30,$31
	
sine2
;86,32
	db $20,$22,$25,$27,$29,$2B,$2E,$30,$32,$34,$35,$37,$39,$3A,$3B,$3C
	db $3D,$3E,$3F,$3F,$40,$40,$40,$40,$3F,$3F,$3E,$3D,$3C,$3B,$3A,$39
	db $37,$35,$34,$32,$30,$2E,$2B,$29,$27,$25,$22,$20,$1E,$1B,$19,$17
	db $15,$12,$10,$0E,$0C,$0B,$09,$07,$06,$05,$04,$03,$02,$01,$01,$00
	db $00,$00,$00,$01,$01,$02,$03,$04,$05,$06,$07,$09,$0B,$0C,$0E,$10
	db $12,$15,$17,$19,$1B,$1E
;170,32
	db $20,$21,$22,$24,$25,$26,$27,$28,$29,$2A,$2C,$2D,$2E,$2F,$30,$31
	db $32,$33,$34,$35,$36,$36,$37,$38,$39,$3A,$3A,$3B,$3C,$3C,$3D,$3D
	db $3E,$3E,$3E,$3F,$3F,$3F,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	db $3F,$3F,$3F,$3E,$3E,$3E,$3D,$3D,$3C,$3C,$3B,$3A,$3A,$39,$38,$37
	db $36,$36,$35,$34,$33,$32,$31,$30,$2F,$2E,$2D,$2C,$2A,$29,$28,$27
	db $26,$25,$24,$22,$21,$20,$1F,$1E,$1C,$1B,$1A,$19,$18,$17,$16,$14
	db $13,$12,$11,$10,$0F,$0E,$0D,$0C,$0B,$0A,$0A,$09,$08,$07,$06,$06
	db $05,$04,$04,$03,$03,$02,$02,$02,$01,$01,$01,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$01,$01,$01,$02,$02,$02,$03,$03,$04,$04,$05
	db $06,$06,$07,$08,$09,$0A,$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$13
	db $14,$16,$17,$18,$19,$1A,$1B,$1C,$1E,$1F
 	
plascolors1
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	;
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	;
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	;
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	db $00,$01,$02,$03,$04,$05,$06,$07,$07,$06,$05,$04,$03,$02,$01,$00
	
plascolors2
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	;
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	;
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	;
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	db $00,$10,$20,$30,$40,$50,$60,$70,$70,$60,$50,$40,$30,$20,$10,$00
	
small_letters	; 256*8 h none
	db $70,$D8,$F8,$D8,$D8,$00,$00,$00
	db $F0,$D8,$F0,$D8,$F0,$00,$00,$00
	db $70,$C0,$C0,$C0,$70,$00,$00,$00
	db $F0,$D8,$D8,$D8,$F0,$00,$00,$00
	db $F8,$C0,$E0,$C0,$F8,$00,$00,$00
	db $F8,$C0,$E0,$C0,$C0,$00,$00,$00
	db $78,$C0,$D8,$D8,$78,$00,$00,$00
	db $D8,$D8,$F8,$D8,$D8,$00,$00,$00
	db $C0,$C0,$C0,$C0,$C0,$00,$00,$00
	db $30,$30,$30,$30,$E0,$00,$00,$00
	db $D8,$D8,$F0,$D8,$D8,$00,$00,$00
	db $C0,$C0,$C0,$C0,$78,$00,$00,$00
	db $7E,$DB,$DB,$DB,$DB,$00,$00,$00
	db $70,$D8,$D8,$D8,$D8,$00,$00,$00
	db $70,$D8,$D8,$D8,$70,$00,$00,$00
	db $F0,$D8,$F0,$C0,$C0,$00,$00,$00
	db $70,$D8,$D8,$70,$18,$00,$00,$00
	db $F0,$D8,$F0,$D8,$D8,$00,$00,$00
	db $70,$C0,$60,$30,$E0,$00,$00,$00
	db $F0,$60,$60,$60,$60,$00,$00,$00
	db $D8,$D8,$D8,$D8,$70,$00,$00,$00
	db $D8,$D8,$D8,$70,$20,$00,$00,$00
	db $DB,$DB,$DB,$DB,$7E,$00,$00,$00
	db $D8,$D8,$70,$D8,$D8,$00,$00,$00
	db $D8,$D8,$78,$18,$70,$00,$00,$00
	db $F0,$30,$60,$C0,$F0,$00,$00,$00
	db $00,$00,$F0,$00,$00,$00,$00,$00
	db $00,$C0,$00,$C0,$00,$00,$00,$00
	db $C0,$C0,$C0,$00,$C0,$00,$00,$00
	db $0C,$18,$30,$60,$C0,$00,$00,$00
	db $38,$78,$D8,$F8,$18,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	
letter_widths
	db 6,6,5,6, 6,6,6,6
	db 3,5,6,6, 9,6,6,6
	db 6,6,5,5, 6,6,9,6
	db 6,5,5,5, 5,7,6,4
	
bits
	db $80,$40,$20,$10,$08,$04,$02,$01,$00
	
scrolltext
	cmap " ",0
	cmap "[",$de
	cmap "]",$22
st0	db "                                         [   ][ ]   [ ][ ][   ]    [ ][   ]  [   ] [  ]    [ ][   ] [   ]                                         "
st1	db "                                        [ ]   [ ]   [ ][ ][ ][ ]   [ ][ ][ ][ ]   [ ][ ]   [ ]   [ ]   [ ]                                        "
st2	db "                                        [ ]   [ ]   [ ][ ][   ]    [ ][ ][ ][   ] [ ][ ]   [ ] [  ]  [  ]                                         "
st3	db "                                        [ ]   [ ]   [ ][ ][ ][ ]   [ ][ ][ ][ ]   [ ][ ]   [ ]   [ ]   [ ]                                        "
st4	db "                                         [   ] [   ] [  ] [   ]    [ ][ ][ ][ ]    [  ]    [ ][   ] [   ]                                         "

cline
	db $55,$55,$31,$31,$31,$31,$31,$31,$31,$31
	db $71,$31,$00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$31,$00,$00,$00,$00,$31,$31
	db $31,$31,$00,$00,$00,$00,$00,$55,$55,$55
tline
	db 1,1,8,9,10,11,12,13,14,15
	db 16,2,0,0,0,0,0,0,0,0
	db 0,0,0,3,0,0,0,0,4,5
	db 6,7,0,0,0,0,0,1,1,1
	
small_scroll_text
	cmap "A",0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25
	cmap "-",26
	cmap ":",27
	cmap "!",28
	cmap "/",29
	cmap "4",30
	cmap " ",31
	db "        "
	db "PRESS SPACE TO CONTINUE - "
	db "CREDITS: INTRO BY CSABO OF LOD - "
	db "MAGAZINE BY ERICH OF UNLIMITED - "
	db "GREETINGS TO ALL PLUS/4 FANS ALL OVER THE WORLD!"
sst_end
	db "          "	
	db $FF
	cmap
	
	org $5800
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $03,$03,$03,$03,$03,$03,$03,$03
	db $0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C
	db $00,$0F,$3F,$3F,$3F,$3F,$3F,$3F
	db $00,$FF,$FF,$FF,$C0,$00,$00,$03
	db $00,$FF,$FF,$FF,$00,$00,$00,$FC
	db $00,$FC,$FF,$FF,$03,$03,$03,$03
	db $00,$03,$03,$03,$03,$03,$03,$03
	db $00,$FF,$00,$3C,$30,$30,$30,$3C
	db $00,$FF,$00,$C3,$C3,$C3,$C3,$F3
	db $00,$FF,$00,$33,$33,$33,$33,$F3
	db $00,$FF,$00,$F3,$33,$C3,$33,$F3
	db $00,$FF,$00,$3F,$33,$33,$33,$33
	db $00,$FF,$00,$3C,$30,$3C,$30,$30
	db $00,$FF,$00,$FC,$CC,$CC,$CC,$FC
	db $00,$C0,$C0,$C0,$C0,$C0,$C0,$C0
	
OFS = 0
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
;eof