snare_freq
	db $B8,$84,$40

bass_freq
	dw $15E,$A9,$40

vol_default
	db 6,8,7,6,5,4,4
	db $FF

Channel1
	dw pat_quiet
	dw pat_bass_intro
	dw pat_drums_bass
	dw pat_drums_bass
	dw pat_drums_only,pat_drums_only,pat_drums_only,pat_drums_only
	dw pat_drums_only,pat_drums_only,pat_drums_only,pat_drums_only
	;
	dw pat_drums_bass
	dw pat_drums_bass
	dw pat_drums_only,pat_drums_only,pat_drums_only,pat_drums_only
	dw 0
	
Channel2
	dw pat_arp_1
	dw pat_arp_1
	dw pat_arp_1
	dw pat_arp_1
	dw pat_arp_1
	dw pat_arp_1
	dw pat_arp_2
	dw pat_arp_3
	dw pat_arp_3
	dw 0
	
LEN = $40

speed = 7

bdr = $F1
snr = $F2
sn = 28

pat_quiet
	db $F0
	db LEN+speed*4
	db OFF,OFF,OFF,OFF
	db OFF,OFF,OFF,OFF
	db OFF,OFF,OFF,OFF
	db OFF,OFF,OFF,OFF
	db END_MARK
	
pat_drums_only        
	db bdr,LEN+3,C1,    $F0,LEN+speed-3, OFF
	db $F0,LEN+1,OFF,   $F0,LEN+speed-1, OFF
	db bdr,LEN+3,C1,    $F0,LEN+speed-3, OFF
	db $F0,LEN+1,OFF,   $F0,LEN+speed-1, OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3, OFF
	db $F0,LEN+1,OFF,   $F0,LEN+speed-1, OFF
	db snr,LEN+1,29,    $F0,LEN+speed-1, OFF
	db $F0,LEN+1,OFF,   $F0,LEN+speed-1, OFF
	;
	db snr,LEN+1,29,    $F0,LEN+speed-1, OFF
	db $F0,LEN+1,OFF,   $F0,LEN+speed-1, OFF
	db snr,LEN+1,29,    $F0,LEN+speed-1, OFF
	db bdr,LEN+3,C1,    $F0,LEN+speed-3, OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3, OFF
	db bdr,LEN+3,C1,    $F0,LEN+speed-3, OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3, OFF
	db bdr,LEN+3,C1,    $F0,LEN+speed-3, OFF
	;
	db END_MARK
	
pat_drums_bass
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, C0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, C0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, C0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, C0
	db snr,LEN+3,27,    $F3,LEN+speed-3, C0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, C0
	db snr,LEN+1,29,    $F3,LEN+speed-1, C0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, C0
	;                      
	db snr,LEN+1,29,    $F3,LEN+speed-1, C0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, C0
	db snr,LEN+1,29,    $F3,LEN+speed-1, C0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, C0
	db snr,LEN+3,27,    $F3,LEN+speed-3, C0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, C0
	db snr,LEN+3,27,    $F3,LEN+speed-3, C0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, C0
	;
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, G0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, G0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, G0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, G0
	db snr,LEN+3,27,    $F3,LEN+speed-3, G0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, G0
	db snr,LEN+1,29,    $F3,LEN+speed-1, G0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, G0
	;
	db snr,LEN+1,29,    $F3,LEN+speed-1, G0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, G0
	db snr,LEN+1,29,    $F3,LEN+speed-1, G0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, G0
	db snr,LEN+3,27,    $F3,LEN+speed-3, G0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, G0
	db snr,LEN+3,27,    $F3,LEN+speed-3, G0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, G0
	;
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, Di0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, Di0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, Di0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, Di0
	db snr,LEN+3,27,    $F3,LEN+speed-3, Di0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, Di0
	db snr,LEN+1,29,    $F3,LEN+speed-1, Di0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, Di0
	;
	db snr,LEN+1,29,    $F3,LEN+speed-1, Di0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, Di0
	db snr,LEN+1,29,    $F3,LEN+speed-1, Di0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, Di0
	db snr,LEN+3,27,    $F3,LEN+speed-3, Di0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, Di0
	db snr,LEN+3,27,    $F3,LEN+speed-3, Di0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, Di0
	;
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, F0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, F0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, F0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, F0
	db snr,LEN+3,27,    $F3,LEN+speed-3, F0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, F0
	db snr,LEN+1,29,    $F3,LEN+speed-1, F0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, F0
	;
	db snr,LEN+1,29,    $F3,LEN+speed-1, F0
	db $F0,LEN+1,OFF,   $F3,LEN+speed-1, F0
	db snr,LEN+1,29,    $F3,LEN+speed-1, F0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, F0
	db snr,LEN+3,27,    $F3,LEN+speed-3, F0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, F0
	db snr,LEN+3,27,    $F3,LEN+speed-3, F0
	db bdr,LEN+3,C1,    $F3,LEN+speed-3, F0
	;
	db END_MARK
	
pat_bass_only
	db $F0,LEN+speed
	;
	db C0,C0,C0,C0,C0,C0,C0,C0
	db C0,C0,C0,C0,C0,C0,C0,C0
	;
	db G0,G0,G0,G0,G0,G0,G0,G0
	db G0,G0,G0,G0,G0,G0,G0,G0
	;
	db Di0,Di0,Di0,Di0,Di0,Di0,Di0,Di0
	db Di0,Di0,Di0,Di0,Di0,Di0,Di0,Di0
	;
	db F0,F0,F0,F0,F0,F0,F0,F0
	db F0,F0,F0,F0,F0,F0,F0,F0
	;
	db END_MARK
	
pat_bass_intro
	db $F3,LEN+speed*2
	;
	db C0,OFF,OFF,C0
	db C0,OFF,OFF,OFF
	;
	db G0,OFF,OFF,G0
	db G0,OFF,OFF,OFF
	;
	db Di0,OFF,OFF,Di0
	db Di0,OFF,OFF,OFF
	;
	db F0,OFF,OFF,F0
	;
	db snr,LEN+3,27,    $F3,LEN+speed*2-3,F0
	db snr,LEN+3,27,    $F0,LEN+speed*2-3,OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3,  OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3,  OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3,  OFF
	db snr,LEN+3,27,    $F0,LEN+speed-3,  OFF
	;
	db END_MARK
	
pat_arp_1
	db $F3
	db LEN+speed
	db C2,G2,C3,D3
	db C2,G2,C3,D3
	db C2,G2,C3,D3
	db C2,G2,C3,D3
	;
	db B1,G2,C3,D3
	db B1,G2,C3,D3
	db B1,G2,C3,D3
	db B1,G2,C3,D3
	;
	db Ai1,G2,C3,D3
	db Ai1,G2,C3,D3
	db Ai1,G2,C3,D3
	db Ai1,G2,C3,D3
	;
	db A1,G2,C3,D3
	db A1,G2,C3,D3
	db A1,G2,C3,D3
	db A1,G2,C3,D3
	;
	db END_MARK
	
pat_arp_2
	db $F3
	db LEN+speed
	db C2,G2,C3,C2,G2,C3,D3,C3
	db C2,G2,C3,C2,G2,C3,D3,C3
	;
	db B1,G2,C3,B1,G2,C3,D3,C3
	db B1,G2,C3,B1,G2,C3,D3,C3
	;
	db Ai1,G2,C3,Ai1,G2,C3,D3,C3
	db Ai1,G2,C3,Ai1,G2,C3,D3,C3
	;
	db A1,G2,C3,A1,G2,C3,D3,C3
	db A1,G2,C3,A1,G2,C3,D3,C3
	;
	db END_MARK
	
pat_arp_3
	db $F3
	db LEN+speed
	db C2,G2,C3,C2,G2,C3,D3,C3
	db C2,G2,C3,C2,G2,C3,D3,G3
	;
	db B1,G2,C3,B1,G2,C3,D3,C3
	db B1,G2,C3,B1,G2,C3,D3,G3
	;
	db Ai1,G2,C3,Ai1,G2,C3,D3,C3
	db Ai1,G2,C3,Ai1,G2,C3,D3,G3
	;
	db A1,G2,C3,A1,G2,C3,D3,C3
	db A1,G2,C3,A1,G2,C3,D3,G3
	;
	db END_MARK

;[eof]